Debian Bug report logs - #553928
Change dpkg-source to produce new source formats by default

version graph

Package: dpkg-dev; Maintainer for dpkg-dev is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg-dev is src:dpkg.

Reported by: Raphael Hertzog <hertzog@debian.org>

Date: Mon, 2 Nov 2009 11:09:10 UTC

Severity: wishlist

Fixed in version dpkg/1.15.7

Done: Guillem Jover <guillem@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#553928; Package dpkg-dev. (Mon, 02 Nov 2009 11:09:22 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
New Bug report received and forwarded. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Mon, 02 Nov 2009 11:09:22 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: submit@bugs.debian.org
Subject: Change dpkg-source to produce new source formats by default
Date: Mon, 2 Nov 2009 11:50:32 +0100
Package: dpkg-dev
Severity: wishlist

It's been my plan since some time to modify dpkg-source to produce new
source formats by default, now that the archive accepts the new formats,
it's about time to look closer on how to make this happen.

For Debian as a whole, we need to fix the bugs listed here:
http://bugs.debian.org/cgi-bin/pkgreport.cgi?users=hertzog@debian.org;tag=3.0-quilt-by-default

For dpkg-dev, we need to decide on how to handle this auto-conversion.
Currently, dpkg-source has a logic to write the source format into
debian/source/format at unpack time when the format is different from
"1.0" (see Dpkg::Source::Package::extract()). This ensures that the
non-default format is reused for the next build.

This would need to be revisited obviously if 1.0 is no longer the default
format.

In theory, uploads to (old)?stable(-security)?/p-u are built with the
dpkg-source in that suite so they should not be affected by this change
but maybe there are some measures to take to avoid problems nevertheless?

Cheers,
-- 
Raphaël Hertzog




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#553928; Package dpkg-dev. (Wed, 25 Nov 2009 08:54:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Gerfried Fuchs <rhonda@deb.at>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 25 Nov 2009 08:54:09 GMT) Full text and rfc822 format available.

Message #10 received at 553928@bugs.debian.org (full text, mbox):

From: Gerfried Fuchs <rhonda@deb.at>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 557667@bugs.debian.org, 553928@bugs.debian.org
Subject: Re: Bug#557667: dpkg-dev: behaving differently wether quilt is installed or not
Date: Wed, 25 Nov 2009 09:51:02 +0100
block 553928 with 557667
thanks

* Raphael Hertzog <hertzog@debian.org> [2009-11-23 22:14:01 CET]:
> notfound 557667 1.13.26
> found 557667 1.14.25
> thanks

 Sorry. :)

> On Mon, 23 Nov 2009, Gerfried Fuchs wrote:
> > Behaving differently wether quilt is installed or not is working against
> > the principles of least surprise, results in FTBFS in certain areas, and
> > is a hassle.
> 
> Would it be more acceptable if it could no more lead to FTBFS at all?

 That's a bit overrated, please keep the discussion to a sensible level.
Though, either it should built conflict with quilt, or build-depend on
quilt, or not produce FTBFS in these areas. This is one big reason to
*not* switch to default 3.0 (quilt) source format.

> What other hassle have you identified apart from the problem that you
> can't use quilt if you had it not installed at unpack time?

 None that I am yet aware of but I'm not certain that there are no
others. Not having dpkg, as a toolchain program, behave reliable in
exactly the same way in all areas is just calling for troubles,
possibly forseeable and not yet forseeable ones.

> >  Fix for this would be to Depend on quilt to make sure that it's always
> > installed and make dpkg-source -x behave *exactly the same* all the
> > time. Another fix for it would be to make dpkg-source -x be able to do
> > that even without quilt installed.
> 
> What do you mean by "do that"? Creating the .pc directory used by quilt?

 Yes, so that dpkg-source -x behaves exactly the same, no matter wether
quilt is installed or not.

> > But it is important to have dpkg-source behave idempotent, otherwise
> > there will be lots of different areas things can (and will) break.
> 
> I'm all for fixing dpkg-source to avoid those breakage when you discover
> them but I don't want to have dpkg-source recreate .pc without using quilt
> and guillem would like to avoid the quilt dependency.

 Then we are at a deadlock here and this means the dead for the push of
3.0 (quilt) as default, sorry. You claimed that quilt using packages
won't need to change anything, now it turns out that the quilt handling
has to be removed - and given that things *have* to be changed switching
the default can't happen.

 Feel free to close this bugreport when you remove the intention to fix
#553928 without making it a wontfix. :)  Unfortunately I don't see any
other way round that.

 Thanks. :)
Rhonda




Added blocking bug(s) of 553928: 557667 Request was from Gerfried Fuchs <rhonda@deb.at> to control@bugs.debian.org. (Wed, 25 Nov 2009 10:51:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#553928; Package dpkg-dev. (Wed, 25 Nov 2009 14:36:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 25 Nov 2009 14:36:07 GMT) Full text and rfc822 format available.

Message #17 received at 553928@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Gerfried Fuchs <rhonda@deb.at>
Cc: 557667@bugs.debian.org, 553928@bugs.debian.org
Subject: Re: Bug#557667: dpkg-dev: behaving differently wether quilt is installed or not
Date: Wed, 25 Nov 2009 15:33:58 +0100
On Wed, 25 Nov 2009, Gerfried Fuchs wrote:
> block 553928 with 557667

It's not up to you to decide such things...

> > Would it be more acceptable if it could no more lead to FTBFS at all?
> 
>  That's a bit overrated, please keep the discussion to a sensible level.

The remark is serious, I committed changes so that when dpkg calls quilt
it will behave as strictly as the internal dpkg-source implementation. So
you will no longer have FTBFS due to fuzzy patches. It will fail to build
the source package on the maintainer machine directly (until he refreshes
the patches).

The only remaining known problem is the one you where you unpack without
quilt and try to use quilt afterwards. And this one doesn't have to wait
that this bug is fixed but that all buildd use an sbuild recent enough
so that the source package is extracted in the build environment (so
build-depending on quilt is enough to ensure that it's properly unpacked).

> > I'm all for fixing dpkg-source to avoid those breakage when you discover
> > them but I don't want to have dpkg-source recreate .pc without using quilt
> > and guillem would like to avoid the quilt dependency.
> 
>  Then we are at a deadlock here and this means the dead for the push of
> 3.0 (quilt) as default, sorry. You claimed that quilt using packages
> won't need to change anything, now it turns out that the quilt handling
> has to be removed - and given that things *have* to be changed switching
> the default can't happen.

I might change my opinion though, after discussing with quilt's upstream,
he thinks it's reasonable to recreate the .pc even without quilt.

Cheers,
-- 
Raphaël Hertzog




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#553928; Package dpkg-dev. (Wed, 25 Nov 2009 14:51:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Gerfried Fuchs <rhonda@deb.at>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 25 Nov 2009 14:51:02 GMT) Full text and rfc822 format available.

Message #22 received at 553928@bugs.debian.org (full text, mbox):

From: Gerfried Fuchs <rhonda@deb.at>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 557667@bugs.debian.org, 553928@bugs.debian.org
Subject: Re: Bug#557667: dpkg-dev: behaving differently wether quilt is installed or not
Date: Wed, 25 Nov 2009 15:47:21 +0100
* Raphael Hertzog <hertzog@debian.org> [2009-11-25 15:33:58 CET]:
> On Wed, 25 Nov 2009, Gerfried Fuchs wrote:
> > block 553928 with 557667
> 
> It's not up to you to decide such things...

 It's no decision, it's a fact that the resolution of this is hindering
switching the 3.0 (quilt) format on by default, I don't know what this
has to do with any "deciding".

> > > Would it be more acceptable if it could no more lead to FTBFS at all?
> > 
> >  That's a bit overrated, please keep the discussion to a sensible level.
> 
> The remark is serious, I committed changes so that when dpkg calls quilt
> it will behave as strictly as the internal dpkg-source implementation. So
> you will no longer have FTBFS due to fuzzy patches. It will fail to build
> the source package on the maintainer machine directly (until he refreshes
> the patches).

 dpkg won't be able to make package "no more lead to FTBFS at all",
there will always be areas out of the scope of dpkg that lead to
FTBFSes. Or you meant something different, but then I have no clue on
what you meant with it.

> The only remaining known problem is the one you where you unpack without
> quilt and try to use quilt afterwards. And this one doesn't have to wait
> that this bug is fixed but that all buildd use an sbuild recent enough
> so that the source package is extracted in the build environment (so
> build-depending on quilt is enough to ensure that it's properly unpacked).

 Sorry, but you said yourself, don't sweat on sbuild too much. Actually,
having sbuild "fixed" would be a workaround for the core problem, and
won't solve that dpkg is behaving differently with quilt installed or
not. But I'm repeating myself and will refrain from iterating this
discussion again in case you don't bring up anything new.

 You are aware that dpkg is most probably the most central tool for
Debian (and its derivates) and actually it is crucial that it behaves in
a clear defined way and not differently depending on other packages
installed or not. The current situation isn't giving this, and that
alone should be reason enough against this format as default.

> >  Then we are at a deadlock here and this means the dead for the push of
> > 3.0 (quilt) as default, sorry. You claimed that quilt using packages
> > won't need to change anything, now it turns out that the quilt handling
> > has to be removed - and given that things *have* to be changed switching
> > the default can't happen.
> 
> I might change my opinion though, after discussing with quilt's upstream,
> he thinks it's reasonable to recreate the .pc even without quilt.

 If that works in a relieable way and dpkg won't behave differently when
quilt is installed or when it is not installed then that might be called
a solution to the situation, indeed.

 So long,
Rhonda




Added tag(s) pending. Request was from Raphaël Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Sun, 28 Mar 2010 16:30:13 GMT) Full text and rfc822 format available.

Message sent on to Raphael Hertzog <hertzog@debian.org>:
Bug#553928. (Sun, 28 Mar 2010 16:30:16 GMT) Full text and rfc822 format available.

Message #27 received at 553928-submitter@bugs.debian.org (full text, mbox):

From: Raphaël Hertzog <hertzog@debian.org>
To: 553928-submitter@bugs.debian.org
Subject: Bug#553928 marked as pending
Date: Sun, 28 Mar 2010 16:25:30 +0000
tag 553928 pending
thanks

Hello,

Bug #553928 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=dpkg/dpkg.git;a=commitdiff;h=ce14c94

---
commit ce14c941fa4a02388011a0c7c7e60a86e820aadd
Author: Raphaël Hertzog <hertzog@debian.org>
Date:   Sun Mar 28 16:57:18 2010 +0200

    dpkg-source: warn when debian/source/format doesn't exist
    
    Document in dpkg-source(1) the fact that the fallback to "1.0"
    when debian/source/format doesn't exist is deprecated. Explain
    the rationale.
    
    Document the long-term deprecation in README.feature-removal-schedule.

diff --git a/debian/changelog b/debian/changelog
index 74d3fed..ba1a89a 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,9 +1,17 @@
-dpkg (1.15.6.2) experimental; urgency=low
+dpkg (1.15.6.2) UNRELEASED; urgency=low
+
+  [ Raphaël Hertzog ]
+  * Clarify the plan concerning dpkg-source, debian/source/format and
+    the default source format in dpkg-source(1). Add a warning
+    in dpkg-source to invite people to always create debian/source/format.
+    We deprecate the fallback to "1.0" (it's there for backwards compatibility
+    only) and debian/source/format is going to be mandatory at some point in
+    the future. Closes: #553928
 
   [ Updated man page translations ]
   * German (Helge Kreutzmann).
 
- -- Helge Kreutzmann <debian@helgefjell.de>  Sun, 28 Mar 2010 17:37:20 +0200
+ -- Raphaël Hertzog <hertzog@debian.org>  Sun, 28 Mar 2010 16:46:04 +0200
 
 dpkg (1.15.6.1) experimental; urgency=low
 




Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. (Wed, 21 Apr 2010 03:36:09 GMT) Full text and rfc822 format available.

Notification sent to Raphael Hertzog <hertzog@debian.org>:
Bug acknowledged by developer. (Wed, 21 Apr 2010 03:36:09 GMT) Full text and rfc822 format available.

Message #32 received at 553928-close@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 553928-close@bugs.debian.org
Subject: Bug#553928: fixed in dpkg 1.15.7
Date: Wed, 21 Apr 2010 03:34:27 +0000
Source: dpkg
Source-Version: 1.15.7

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive:

dpkg-dev_1.15.7_all.deb
  to main/d/dpkg/dpkg-dev_1.15.7_all.deb
dpkg_1.15.7.dsc
  to main/d/dpkg/dpkg_1.15.7.dsc
dpkg_1.15.7.tar.bz2
  to main/d/dpkg/dpkg_1.15.7.tar.bz2
dpkg_1.15.7_amd64.deb
  to main/d/dpkg/dpkg_1.15.7_amd64.deb
dselect_1.15.7_amd64.deb
  to main/d/dpkg/dselect_1.15.7_amd64.deb
libdpkg-dev_1.15.7_amd64.deb
  to main/d/dpkg/libdpkg-dev_1.15.7_amd64.deb
libdpkg-perl_1.15.7_all.deb
  to main/d/dpkg/libdpkg-perl_1.15.7_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 553928@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Guillem Jover <guillem@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 21 Apr 2010 04:05:55 +0200
Source: dpkg
Binary: libdpkg-dev dpkg dpkg-dev libdpkg-perl dselect
Architecture: source amd64 all
Version: 1.15.7
Distribution: unstable
Urgency: low
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Changed-By: Guillem Jover <guillem@debian.org>
Description: 
 dpkg       - Debian package management system
 dpkg-dev   - Debian package development tools
 dselect    - Debian package management front-end
 libdpkg-dev - Debian package management static library
 libdpkg-perl - Dpkg perl modules
Closes: 514316 546577 553928 556889 559519 560070 568566 574599 575706 575891 577756 578162
Changes: 
 dpkg (1.15.7) unstable; urgency=low
 .
   [ Raphaël Hertzog ]
   * Clarify the plan concerning dpkg-source, debian/source/format and
     the default source format in dpkg-source(1). Add a warning
     in dpkg-source to invite people to always create debian/source/format.
     We deprecate the fallback to "1.0" (it's there for backwards compatibility
     only) and debian/source/format is going to be mandatory at some point in
     the future. Closes: #553928
   * Add .gitattributes to list of files ignored by dpkg-source.
   * Document most common warnings and errors of dpkg-source in its manual
     page.
   * Let dpkg-source read options from debian/source/local-options as well but
     do not include that file in the generated source package.
   * Improve explanation of --all option in dpkg-parsechangelog(1). Thanks to
     Jari Aalto. Closes: #575706
   * Fix dpkg to not lose package metadata on filesystems where readdir()
     returns new files added after the opendir() call, btrfs in particular
     triggered the problematic behaviour. Closes: #575891
   * Tigthen the regex used by dpkg-source to match the component name of
     supplementary tarballs so that undercore (_) are not allowed as it was
     supposed to be.
   * Introduce a new script called dpkg-buildflags: its purpose is to retrieve
     compilation flags and it should be used within debian/rules to pass
     the right compilation flags to the build process. dpkg-builpackage still
     exports them to not break packages currently relying on them but packages
     should now start using dpkg-buildflags instead. Closes: #560070
   * For Ubuntu set default value of LDFLAGS to -Wl,-Bsymbolic-functions.
   * Cleanup some old Conflicts/Replaces, thanks to Helge Kreutzmann.
   * Modify dselect to treat all unknown package as known and marked for purge.
     This is a temporary work-around so that dselect doesn't try to reinstall
     packages of priority > standard that were removed or not installed. Thanks
     to Robert Luderda for the patch. Closes: #559519, #556889
   * dpkg now exports DPKG_MAINTSCRIPT_NAME to maintainer scripts with the
     type of maintainer script currently running (preinst, postinst, prerm,
     postrm). Closes: #546577
   * dpkg now exports DPKG_LIBDIR to maintainer scripts pointing to the
     private directory containing internal programs like the upcoming
     maintscript-helper.
   * Add $DPKG_LIBDIR/maintscript-helper program that can be used in
     maintainer scripts to perform common operations working around
     current dpkg limitations: first version supports removing obsolete
     conffiles and renaming conffiles. Closes: #514316
   * Fix "dpkg-scansources -e", it was calling a non-existing function.
     Closes: #578162
   * Add new script dpkg-mergechangelogs to do 3-way merges of Debian
     changelogs. Add libalgorithm-merge-perl to Recommends for the
     benefit of this script.
 .
   [ Colin Watson ]
   * Modern tar files typically use NormalFile1 rather than NormalFile0 for
     file objects. A typo meant that the former never triggered rename
     deferral. Closes: #577756
   * Use the new list of files on rename deferral instead of old one, so that
     newly added files get installed.
 .
   [ Guillem Jover ]
   * Report deferred trigger errors on status-fd. Closes: #574599
     Thanks to Michael Vogt <michael.vogt@ubuntu.com>.
   * When creating hard links to normal files on extraction use the .dpkg-new
     filename for source as the file is not yet in place due to the rename
     deferral. Thanks to Colin Watson for the initial patch.
   * Do not output the Package-Type field on udeb.
   * Fix versioned Replaces to not produce file overwrite errors on downgrades.
     Closes: #568566
   * Fix installation of replaced and replacing packages in reverse order
     (first the replacing then the replaced) for which the replaced package
     is supposed to get disappeared, to disappear the correct package and not
     lose track of the ownership of the replaced files.
 .
   [ Updated dpkg translations ]
   * German (Sven Joachim).
 .
   [ Updated dselect translations ]
   * German (Sven Joachim).
 .
   [ Updated man page translations ]
   * German (Helge Kreutzmann).
 .
   [ Updated scripts translations ]
   * German (Helge Kreutzmann).
Checksums-Sha1: 
 2f096f1027105eb1a9950692cda75d338c4b52c7 1213 dpkg_1.15.7.dsc
 fdf14a74370fb9daac4a67d703f6e60c20eaec51 4872332 dpkg_1.15.7.tar.bz2
 ccc84900a91c120d260153f3095a43445013548e 371632 libdpkg-dev_1.15.7_amd64.deb
 41ab7052b7d606749f434dc519388b6d1821ae22 2062348 dpkg_1.15.7_amd64.deb
 4a5fbbf048151f1468a00155cf13daa0ce6aea86 828512 dselect_1.15.7_amd64.deb
 6760d76f7b085b8e2c2d7f6dfec4d69984413823 648164 dpkg-dev_1.15.7_all.deb
 6a28af1efa9b249a4536b4cc10d8e61d9dfb9925 578192 libdpkg-perl_1.15.7_all.deb
Checksums-Sha256: 
 d8d261e40d6d0f48dd39dee867cfcb0eb2385423fc9ee5948657a6785406bddd 1213 dpkg_1.15.7.dsc
 f8d0a779361f3fd7f89a138cd632a4ab47f62ca1ccd0f393f2e81be899605e4f 4872332 dpkg_1.15.7.tar.bz2
 e8470ce90649f17a05f1e9d47e440ae2568feb0946e514431ba579130afe9378 371632 libdpkg-dev_1.15.7_amd64.deb
 077c270b0f31181081751b8a66a98a9ca598d1b64a689218e882d2841f8b6bbe 2062348 dpkg_1.15.7_amd64.deb
 0e0d45a5001dcbafbfb36b789b3c6316ddd7cb4d9d4d4cf847912a7273932aa7 828512 dselect_1.15.7_amd64.deb
 ca757de11c7a65791e67d807068ef5d592605dbce7632ed4b83d94715fb9acd0 648164 dpkg-dev_1.15.7_all.deb
 05fc8150c8b8ea29315d8a5f1a48d8cb7453d1ce1a95a3af492f3e8acec7461d 578192 libdpkg-perl_1.15.7_all.deb
Files: 
 2df9bfed2c1c2342da2196925ab597fb 1213 admin required dpkg_1.15.7.dsc
 f4638fd8a623aa48efd62b48644b1ab3 4872332 admin required dpkg_1.15.7.tar.bz2
 508f4f97ac08d1e23f98fad3801535fe 371632 libdevel optional libdpkg-dev_1.15.7_amd64.deb
 c9d13d664114569a3884721f52a2b8b5 2062348 admin required dpkg_1.15.7_amd64.deb
 ca86a0334edbbaef23354ada093473a6 828512 admin optional dselect_1.15.7_amd64.deb
 e850c25f7e57b1b570181b94522259de 648164 utils optional dpkg-dev_1.15.7_all.deb
 2ff2c47b5e043f0704b90b1245fb3614 578192 perl optional libdpkg-perl_1.15.7_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAkvOZUkACgkQuW9ciZ2SjJt4TgCeNn227r3zWFjOyy/12jo6WH9z
XLwAoNjTBZAyEb30antcMbFdZvgtP1h8
=egWK
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 20 May 2010 07:34:25 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 10:06:53 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.